//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "faddrep.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FR_Class"
#pragma link "FR_DBSet"
#pragma link "FR_DCtrl"
#pragma link "FR_Desgn"
#pragma link "FR_DSet"
#pragma link "FR_FIBDB"
#pragma link "FR_BDEDB"
#pragma resource "*.dfm"
TFormAddRep *FormAddRep;
//---------------------------------------------------------------------------
__fastcall TFormAddRep::TFormAddRep(TComponent* Owner, TMenuItem* NMP, char *sp)
        : TForm(Owner), NMPrint(NMP), sWay(sp)
{
   LoadIniFile();
   SetMenuItems();

   for(int i=0; i<Application->ComponentCount; i++){
     if(dynamic_cast<TfrDesigner*>(Application->Components[i])) return;
      }

   try{
      frDesigner1 = new TfrDesigner(this);
      }catch(...){
        ShowMessage("   TfrDesigner -   .");
        }
}
//---------------------------------------------------------------------------
void __fastcall TFormAddRep::bAddClick(TObject *Sender)
{
     frRep1->Clear();
     frRep1->DesignReport();
}
//---------------------------------------------------------------------------
void __fastcall TFormAddRep::bSaveClick(TObject *Sender)
{
   TIniFile *Ini = new TIniFile(sWay+"Rep.ini");
   Ini->WriteInteger("RepCount","Count",VList->Strings->Count);
      for(int i=0; i<VList->Strings->Count; i++){
         Ini->WriteString(IntToStr(i+1), "MenuName", VList->Cells[0][i+1]);
         Ini->WriteString(IntToStr(i+1), "FileName", VList->Cells[1][i+1]);
         }
   delete Ini;

   SetMenuItems();
}
//---------------------------------------------------------------------------
void __fastcall TFormAddRep::VListDblClick(TObject *Sender)
{
  if(VList->Cells[1][VList->Row] != "") ODM->FileName = VList->Cells[1][VList->Row];
  if(ODM->Execute()) VList->Cells[1][VList->Row] = ODM->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TFormAddRep::LoadIniFile()
{
   AnsiString sm, sf;
   VList->Strings->Clear();
   TIniFile *Ini = new TIniFile(sWay+"Rep.ini");
   if(Ini != NULL && Ini->ValueExists("RepCount","Count")){
      int crep = Ini->ReadInteger("RepCount","Count",0);
      for(int i=0; i<crep; i++){
         sm = Ini->ReadString(IntToStr(i+1), "MenuName", "");
         sf = Ini->ReadString(IntToStr(i+1), "FileName", "");
         VList->Strings->Add(sm+"="+sf);
         }
      }
   delete Ini;
}
//---------------------------------------------------------------------------
void __fastcall TFormAddRep::SetMenuItems()
{
      NMPrint->Clear();
      for(int i=0; i<VList->Strings->Count; i++){
         TMenuItem* Itm = new TMenuItem(NMPrint);
         Itm->Caption = VList->Cells[0][i+1];
         Itm->Tag = i;
         Itm->OnClick = RepClick;
         NMPrint->Add(Itm);
         }
}
//---------------------------------------------------------------------------

void __fastcall TFormAddRep::RepClick(TObject* Sender)
{
    int nv = ((TMenuItem*)Sender)->Tag+1;
    try{
     if(!FileExists(VList->Cells[1][nv])) throw 1;
       }catch(...){
           ShowMessage("  : "+VList->Cells[1][nv]);  return;
           }
    frRep1->LoadFromFile(VList->Cells[1][nv]);
    frRep1->ShowReport();
}
//---------------------------------------------------------------------------

void __fastcall TFormAddRep::bConstrClick(TObject *Sender)
{
    if(VList->Strings->Count == 0) return;
    int nv = VList->Row;
    try{
     if(!FileExists(VList->Cells[1][nv])) throw 1;
       }catch(...){
           ShowMessage("  : "+VList->Cells[1][nv]);  return;
           }
    frRep1->LoadFromFile(VList->Cells[1][nv]);
    frRep1->DesignReport();
}
//---------------------------------------------------------------------------

void __fastcall TFormAddRep::ShowFormAddRep()
{
   LoadIniFile();
   SetMenuItems();
   ShowModal();
}
//--------

void __fastcall TFormAddRep::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
   if(Key == VK_DELETE && Shift.Contains(ssCtrl) && VList->Strings->Count){
     AnsiString s = "   : \""+VList->Cells[0][VList->Row]+"\"";
     if(Application->MessageBox(s.c_str(),"    ",
        MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2) == IDNO) { Key = 0; }
        else { VList->DeleteRow(VList->Row); Key = 0; }
     }
}
//---------------------------------------------------------------------------

