//---------------------------------------------------------------------------

#ifndef faddrepH
#define faddrepH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "FR_Class.hpp"
#include "FR_DBSet.hpp"
#include "FR_DCtrl.hpp"
#include "FR_Desgn.hpp"
#include "FR_DSet.hpp"
#include "FR_FIBDB.hpp"
#include <Buttons.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>
#include <Dialogs.hpp>
#include "FR_BDEDB.hpp"

//---------------------------------------------------------------------------
class TFormAddRep : public TForm
{
__published:	// IDE-managed Components
        TValueListEditor *VList;
        TBitBtn *bAdd;
        TBitBtn *bSave;
        TBitBtn *bExit;
        TOpenDialog *ODM;
        TfrBDEComponents *frBDEComponents1;
        TfrReport *frRep1;
        TfrDialogControls *frDialogControls1;
        TfrFIBComponents *frFIBComponents1;
        TSpeedButton *bConstr;
        void __fastcall bAddClick(TObject *Sender);
        void __fastcall bSaveClick(TObject *Sender);
        void __fastcall VListDblClick(TObject *Sender);
        void __fastcall bConstrClick(TObject *Sender);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);

private:	// User declarations
        TMenuItem* NMPrint;
        AnsiString sWay;
        void __fastcall LoadIniFile();
        void __fastcall SetMenuItems();
public:		// User declarations
        __fastcall TFormAddRep(TComponent* Owner, TMenuItem* NMP, char *sp);
        void __fastcall RepClick(TObject* Sender);
        TfrDesigner* frDesigner1;
        void __fastcall ShowFormAddRep();
};
//---------------------------------------------------------------------------
extern PACKAGE TFormAddRep *FormAddRep;
//---------------------------------------------------------------------------
#endif
